// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3)
// Source File Name:   TextPrinter.java

package com.java4less.textprinter;

import com.java4less.charsets.CharSetManager;
import com.java4less.charsets.Charset;
import java.awt.Font;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.util.*;

// Referenced classes of package com.java4less.textprinter:
//            Command, TextProperties, TextPrinterException, CommandParamValue,
//            CommandCharSetValue, JobProperties, PaperSize, PrinterPort

public abstract class TextPrinter {

  public TextPrinter() {
    commands = new Hashtable();
    fontValues = new Hashtable();
    charSetValues = new Hashtable();
    pitchValues = new Hashtable();
    interspacingValues = new Hashtable();
    paperSizeValues = new Hashtable();
    resolutionValues = new Hashtable();
    cmdDependencies = new Hashtable();
    bLFfterCR = true;
    pageData = null;
    pageDataProperties = null;
    jobSetup = null;
    currentRow = 0;
    currentCol = 0;
    port = null;
    bufferSize = 100;
    bufferPointer = 0;
    buffer = new byte[bufferSize + 1];
    leftMarginPerSoftware = false;
    topMarginPerSoftware = false;
    feedFormPerSoftware = true;
    hLineChar = '-';
    vLineChar = '|';
    vrLineChar = '+';
    vlLineChar = '+';
    htLineChar = '+';
    hbLineChar = '+';
    crossLineChar = '+';
    tlCornerChar = '+';
    trCornerChar = '+';
    blCornerChar = '+';
    brCornerChar = '+';
    linesCharSet = null;
    performCharSetConversion = true;
    defaultCharSet = "";
    debug = false;
    calculatePitchAndHMI = false;
    calculateLineSpacing = false;
    charSetManager = CharSetManager.getInstance();
    currentProp = null;
    emptyCharater = '\0';
  }

  protected void init() {
  }

  protected void setCommand(Command cmd) {
    if (!commands.containsKey(cmd.getName())) {
      commands.put(cmd.getName(), cmd);
    }
  }

  protected Command getCommand(String name) {
    if (commands.containsKey(name)) {
      return (Command) commands.get(name);
    }
    else {
      return null;
    }
  }

  protected void executeCommand(String name, String param) throws
      TextPrinterException {
    executeCommandInternal(name, param);
  }

  protected final void executeCommandInternal(String name, String param) throws
      TextPrinterException {
    Command cmd = getCommand(name);
    if (cmd != null) {
      addToBuffer(replaceParameter(cmd.getCommand(), param));
      if (debug) {
        System.out.println(String.valueOf(String.valueOf( (new StringBuffer(
            String.valueOf(String.valueOf(cmd.getName())))).append(" : ").
            append(param))));
      }
      executeDependencies(name);
    }
  }

  protected void executeCommand(String name) throws TextPrinterException {
    executeCommandInternal(name);
  }

  protected final void executeCommandInternal(String name) throws
      TextPrinterException {
    Command cmd = getCommand(name);
    if (cmd != null) {
      addToBuffer(cmd.getCommand());
      if (debug) {
        System.out.println(cmd.getName());
      }
      executeDependencies(name);
    }
  }

  public void setBufferSize(int s) {
    byte newBuffer[] = new byte[bufferSize + 1];
    bufferSize = s;
    for (int i = 0; i < buffer.length && i < newBuffer.length; i++) {
      newBuffer[i] = buffer[i];

    }
    buffer = newBuffer;
  }

  public int getBufferSize() {
    return bufferSize;
  }

  public void setLFafterCR(boolean b) {
    bLFfterCR = b;
  }

  private void printChar(char c, int row, int col, TextProperties t) {
    printString("".concat(String.valueOf(String.valueOf(c))), row, col, t);
  }

  public void printString(String s, int row, int col, TextProperties t) {
    if (t == null) {
      t = new TextProperties();
    }
    TextProperties tCloned = t.getClone();
    for (int i = 0;
         i < s.length() && col + i <= jobSetup.cols - jobSetup.rightMargin; i++) {
      if (row >= pageData.length || col + i >= pageData[0].length) {
        continue;
      }
      try {
        pageData[row][col + i] = s.charAt(i);
        pageDataProperties[row][col + i] = tCloned;
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }

  }

  public void printString(String s, int row, int col) {
    printString(s, row, col, getDefaultTextProperties());
  }

  public void printString(String s, TextPoint pos) {
    if (pos != null) {
      printString(s, pos.row, pos.col, getDefaultTextProperties());
    }
  }

  public void printString(String s, int row, int col, Font font) {
    TextProperties p = new TextProperties();
    p.bold = font.isBold();
    p.italic = font.isItalic();
    p.fontName = font.getFontName();
    printString(s, row, col, p);
  }

  public void newLine() throws TextPrinterException {
    currentRow = currentRow + 1;
    currentCol = jobSetup.leftMargin;
    if (currentRow > jobSetup.rows - jobSetup.bottomMargin) {
      finishPage();
    }
  }

  protected boolean supportsCommand(String scmd) {
    Command cmd = getCommand(scmd);
    if (cmd == null) {
      return false;
    }
    return cmd.getCommand().length() != 0;
  }

  public void newPage() throws TextPrinterException {
    finishPage();
  }

  public void printHorizontalLine() {
    printHorizontalLine(currentRow, currentCol,
                        jobSetup.cols - jobSetup.rightMargin);
  }

  public void printHorizontalLine(int row, int col1, int col2) {
    TextProperties prop = new TextProperties();
    if (linesCharSet != null && linesCharSet.length() > 0) {
      prop.characterSet = linesCharSet;
    }
    if (col2 < col1) {
      int tmp = col2;
      col2 = col1;
      col1 = tmp;
    }
    for (int i = col1; i <= col2; i++) {
      _$2731(row, i, i == col1, i == col2, prop);

    }
  }

  public void printVerticalLine(int col, int row1, int row2) {
    TextProperties prop = new TextProperties();
    if (linesCharSet != null && linesCharSet.length() > 0) {
      prop.characterSet = linesCharSet;
    }
    if (row2 < row1) {
      int tmp = row2;
      row2 = row1;
      row1 = tmp;
    }
    for (int i = row1; i <= row2; i++) {
      _$2764(i, col, i == row1, i == row2, prop);

    }
  }

  public void printRectangle(int x1, int y1, int x2, int y2) {
    TextProperties prop = new TextProperties();
    if (linesCharSet != null && linesCharSet.length() > 0) {
      prop.characterSet = linesCharSet;
    }
    printHorizontalLine(y1, x1, x2);
    printHorizontalLine(y2, x1, x2);
    printVerticalLine(x1, y1, y2);
    printVerticalLine(x2, y1, y2);
  }

  public void printString(String s) throws TextPrinterException {
    printString(s, getDefaultTextProperties());
  }

  public void printString(String s, TextProperties t) throws
      TextPrinterException {
    printString(s, currentRow, currentCol, t);
    currentCol = currentCol + s.length();
    if (currentCol > jobSetup.cols - jobSetup.rightMargin) {
      currentRow++;
    }
    if (currentRow > jobSetup.rows - jobSetup.bottomMargin) {
      finishPage();
    }
  }

  public void printString(String s, Font font) throws TextPrinterException {
    printString(s, currentRow, currentCol, font);
    currentCol = currentCol + s.length();
    if (currentCol >= jobSetup.cols - jobSetup.rightMargin) {
      currentRow++;
    }
    if (currentRow > jobSetup.rows - jobSetup.bottomMargin) {
      finishPage();
    }
  }

  protected void writeCharToBuffer(char c, TextProperties newProp) throws
      TextPrinterException {
    if (newProp == null) {
      newProp = currentProp.getClone();
    }
    else {
      newProp = newProp.getClone();
    }
    _$2842(newProp);
    byte mappedBytes[] = null;
    try {
      mappedBytes = charMapping(c, newProp);
    }
    catch (UnsupportedEncodingException e) {
      throw new TextPrinterException(e.getMessage());
    }
    if (newProp.characterSet.equals("437")) {
      System.out.println(newProp.characterSet);
    }
    processCommandsForTextProperties(currentProp, newProp);
    String curFont = currentProp.fontName;
    String curCharSet = currentProp.characterSet;
    currentProp = newProp;
    if (currentProp.fontName.length() == 0) {
      currentProp.fontName = curFont;
    }
    if (currentProp.characterSet.length() == 0) {
      currentProp.characterSet = curCharSet;
    }
    addToBuffer(mappedBytes);
  }

  protected void finishPage() throws TextPrinterException {
    byte b[] = new byte[1];
    boolean lastCharWasEmpty = false;
    if (topMarginPerSoftware) {
      for (int h = 0; h < jobSetup.topMargin; h++) {
        b[0] = 13;
        addToBuffer(b);
        if (bLFfterCR) {
          b[0] = 10;
          addToBuffer(b);
        }
      }

    }
    for (int i = jobSetup.topMargin; i < jobSetup.rows - jobSetup.bottomMargin;
         i++) {
      lastCharWasEmpty = false;
      char space = ' ';
      if (topMarginPerSoftware) {
        for (int h = 0; h < jobSetup.leftMargin; h++) {
          writeCharToBuffer(space, null);

        }
      }
      for (int j = jobSetup.leftMargin;
           j < jobSetup.cols - jobSetup.rightMargin; j++) {
        if (pageDataProperties[i][j] == null || pageData[i][j] == emptyCharater) {
          if (!jobSetup.proportional ||
              !supportsCommand(CMD_HORIZONTAL_POSITIONING)) {
            writeCharToBuffer(space, getDefaultTextProperties());
          }
          if (jobSetup.proportional &&
              supportsCommand(CMD_HORIZONTAL_POSITIONING)) {
            lastCharWasEmpty = true;
          }
          continue;
        }
        if (lastCharWasEmpty) {
          moveToHPosition(j);
        }
        TextProperties newProp = pageDataProperties[i][j];
        writeCharToBuffer(pageData[i][j], newProp);
        lastCharWasEmpty = false;
      }

      b[0] = 13;
      addToBuffer(b);
      if (bLFfterCR) {
        b[0] = 10;
        addToBuffer(b);
      }
    }

    b[0] = 12;
    if (feedFormPerSoftware) {
      addToBuffer(b);
    }
    resetPageData();
  }

  protected void moveToHPosition(int col) throws TextPrinterException {
    executeCommand(CMD_HORIZONTAL_POSITIONING,
                   "".concat(String.valueOf(String.valueOf(col))));
  }

  protected void processCommandsForTextProperties(TextProperties current,
                                                  TextProperties next) throws
      TextPrinterException {
    if (current.bold && !next.bold) {
      executeCommand(CMD_BOLD_OFF);
    }
    if (!current.bold && next.bold) {
      executeCommand(CMD_BOLD_ON);
    }
    if (current.italic && !next.italic) {
      executeCommand(CMD_ITALIC_OFF);
    }
    if (!current.italic && next.italic) {
      executeCommand(CMD_ITALIC_ON);
    }
    if (current.underlined && !next.underlined) {
      executeCommand(CMD_UNDERLINED_OFF);
    }
    if (!current.underlined && next.underlined) {
      executeCommand(CMD_UNDERLINED_ON);
    }
    if (current.doubleStrike && !next.doubleStrike) {
      executeCommand(CMD_DOUBLESTRIKE_OFF);
    }
    if (!current.doubleStrike && next.doubleStrike) {
      executeCommand(CMD_DOUBLESTRIKE_ON);
    }
    if (current.doubleWide && !next.doubleWide) {
      executeCommand(CMD_DOUBLEWIDE_OFF);
    }
    if (!current.doubleWide && next.doubleWide) {
      executeCommand(CMD_DOUBLEWIDE_ON);
    }
    if (current.superscript && !next.superscript) {
      executeCommand(CMD_SUPERSCRIPT_OFF);
    }
    if (!current.superscript && next.superscript) {
      executeCommand(CMD_SUPERSCRIPT_ON);
    }
    if (current.subscript && !next.subscript) {
      executeCommand(CMD_SUBSCRIPT_OFF);
    }
    if (!current.subscript && next.subscript) {
      executeCommand(CMD_SUBSCRIPT_ON);
    }
    if (!current.proportional && next.proportional) {
      executeCommand(CMD_PROPORTIONAL_ON);
    }
    if (current.proportional && !next.proportional) {
      executeCommand(CMD_PROPORTIONAL_OFF);
    }
    if (!current.condensed && next.condensed) {
      executeCommand(CMD_CONDENSED_ON);
    }
    if (current.condensed && !next.condensed) {
      executeCommand(CMD_CONDENSED_OFF);
    }
    processCommandsForPitch("".concat(String.valueOf(String.valueOf(current.
        pitch))), "".concat(String.valueOf(String.valueOf(next.pitch))));
    processCommandsForFont(current.fontName, next.fontName);
    if (next.characterSet.length() == 0) {
      next.characterSet = defaultCharSet;
    }
    if (current.characterSet.length() == 0) {
      current.characterSet = defaultCharSet;
    }
    processCommandsForCharacterSet(current.characterSet, next.characterSet);
  }

  protected void addDependency(String mainCommand, String dependent) {
    Vector dep = null;
    if (cmdDependencies.containsKey(mainCommand)) {
      dep = (Vector) cmdDependencies.get(mainCommand);
    }
    if (dep == null) {
      dep = new Vector();
      cmdDependencies.put(mainCommand, dep);
    }
    dep.addElement(dependent);
  }

  protected void executeDependencies(String cmdName) throws
      TextPrinterException {
    Vector dep = null;
    if (cmdDependencies.containsKey(cmdName)) {
      dep = (Vector) cmdDependencies.get(cmdName);
    }
    if (dep == null) {
      return;
    }
    if (debug) {
      System.out.println("Processing dependencies");
    }
    for (int i = 0; i < dep.size(); i++) {
      String depCommand = (String) dep.elementAt(i);
      if (depCommand.equals(CMD_HMI) && jobSetup.columnWidth > (double) 0) {
        executeCommand(CMD_HMI,
                       "".concat(String.valueOf(String.valueOf(jobSetup.
            columnWidth))));
      }
    }

    if (debug) {
      System.out.println("End of dependencies");
    }
  }

  protected String mapTableLookup(Hashtable table, String value) {
    if (table == null) {
      return null;
    }
    for (Enumeration e = table.elements(); e.hasMoreElements(); ) {
      CommandParamValue p = (CommandParamValue) e.nextElement();
      if (p.name.equals(value)) {
        return p.value;
      }
      if (p.name.equals("*")) {
        return p.value;
      }
    }

    return null;
  }

  protected String replaceParameter(String command, String value) {
    int p = command.indexOf("#");
    if (p >= 0) {
      command = String.valueOf(String.valueOf( (new StringBuffer(String.valueOf(
          String.valueOf(command.substring(0, p))))).append(value).append(
          command.substring(p + 1))));
    }
    return command;
  }

  protected void processCommandsForFont(String currentFont, String newFont) throws
      TextPrinterException {
    if (!currentFont.equals(newFont) && !newFont.equals("")) {
      String mappedFont = mapTableLookup(fontValues, newFont);
      if (mappedFont != null) {
        executeCommand(CMD_SELECT_FONT, mappedFont);
      }
    }
  }

  protected void processCommandsPaperSize(PaperSize paper) throws
      TextPrinterException {
    String mappedPaperName = mapTableLookup(paperSizeValues, paper.getName());
    if (mappedPaperName != null) {
      executeCommand(CMD_PAPER_SIZE, mappedPaperName);
    }
  }

  protected void processCommandsResolution(int resolution) throws
      TextPrinterException {
    String mappedRes = mapTableLookup(resolutionValues,
                                      "".concat(String.
                                                valueOf(String.valueOf(resolution))));
    if (mappedRes != null) {
      executeCommand(CMD_RESOLUTION, mappedRes);
    }
  }

  protected String getBestLineSpacing(int lines, double pageHeight) {
    int bestLines = 1000;
    String bestSpacing = "";
    Enumeration e = interspacingValues.elements();
    do {
      if (!e.hasMoreElements()) {
        break;
      }
      CommandParamValue p = (CommandParamValue) e.nextElement();
      if (Integer.parseInt(p.name) >= 60) {
        int j = 1;
        while (j < Integer.parseInt(p.name)) {
          String sp = String.valueOf(String.valueOf( (new StringBuffer("")).
              append(j).append("/").append(p.name)));
          int tmp = getLinesForSpacing(sp, pageHeight);
          if (tmp == lines) {
            return sp;
          }
          if (tmp >= lines && bestLines - lines > tmp - lines) {
            bestLines = tmp;
            bestSpacing = sp;
          }
          j++;
        }
      }
      else {
        String sp = "1/".concat(String.valueOf(String.valueOf(p.name)));
        int tmp = getLinesForSpacing(sp, pageHeight);
        if (tmp == lines) {
          return sp;
        }
        if (tmp >= lines && bestLines - lines > tmp - lines) {
          bestLines = tmp;
          bestSpacing = sp;
        }
      }
    }
    while (true);
    if (debug) {
      System.out.println("Best line spacing:  ".concat(String.valueOf(String.
          valueOf(bestSpacing))));
    }
    return bestSpacing;
  }

  protected int getLinesForSpacing(String spacing, double pageHeight) {
    int p = spacing.indexOf("/");
    String a = spacing.substring(0, p);
    String b = spacing.substring(p + 1);
    int ai = Integer.parseInt(a);
    int bi = Integer.parseInt(b);
    double lines = (pageHeight * (double) bi) / (double) ai;
    return (int) lines;
  }

  protected void processCommandsForCharacterSet(String currentSet,
                                                String newSet) throws
      TextPrinterException {
    if (!currentSet.equals(newSet) && !newSet.equals("")) {
      String mappedSet = mapTableLookup(charSetValues, newSet);
      if (mappedSet != null) {
        executeCommand(CMD_SELECT_CHAR_SET, mappedSet);
      }
    }
  }

  protected void processCommandsForLineSpacing(String spacing) throws
      TextPrinterException {
    int p = spacing.indexOf("/");
    String a = spacing.substring(0, p);
    String b = spacing.substring(p + 1);
    String mappedValue = mapTableLookup(interspacingValues, b);
    if (mappedValue != null) {
      mappedValue = replaceParameter(mappedValue, a);
      executeCommand(CMD_INTERSPACE, mappedValue);
    }
  }

  protected void processCommandsForPitch(String currentPitch, String newPitch) throws
      TextPrinterException {
    if (!currentPitch.equals(newPitch) && !newPitch.equals("")) {
      String mappedPitch = getBestPitchCommand(newPitch);
      if (mappedPitch == null) {
        return;
      }
      mappedPitch = replaceParameter(mappedPitch, newPitch);
      executeCommand(CMD_PITCH, mappedPitch);
    }
  }

  protected String getBestPitchCommand(String pitch) {
    int bestPitch = 0;
    String bestPitchCommand = null;
    double iPitch = Double.parseDouble(pitch);
    Enumeration e = pitchValues.elements();
    do {
      if (!e.hasMoreElements()) {
        break;
      }
      CommandParamValue p = (CommandParamValue) e.nextElement();
      if (p.name.equals("*")) {
        return p.value;
      }
      if (Double.parseDouble(p.name) == iPitch) {
        return p.value;
      }
      if (Double.parseDouble(p.name) > iPitch &&
          Double.parseDouble(p.name) < (double) bestPitch) {
        bestPitch = Integer.parseInt(p.name);
        bestPitchCommand = p.value;
      }
    }
    while (true);
    return bestPitchCommand;
  }

  protected void processCommandsForJob() throws TextPrinterException {
    executeCommand(CMD_RESET);
    processCommandsResolution(jobSetup.resolution);
    if (jobSetup.paperSize != null) {
      processCommandsPaperSize(jobSetup.paperSize);
    }
    if (jobSetup.landscape) {
      executeCommand(CMD_LANDSCAPE);
    }
    else {
      executeCommand(CMD_PORTRAIT);
    }
    if (jobSetup.proportional) {
      executeCommand(CMD_PROPORTIONAL_ON);
    }
    if (!jobSetup.proportional) {
      executeCommand(CMD_PROPORTIONAL_OFF);
    }
    if (calculateLineSpacing) {
      calculateLineSpacing(jobSetup.rows);
    }
    if (calculatePitchAndHMI) {
      calculateColumnWidth(jobSetup.cols);
    }
    if (jobSetup.pitch > (double) 0) {
      processCommandsForPitch("",
                              "".concat(String.valueOf(String.valueOf(jobSetup.
          pitch))));
    }
    if (jobSetup.columnWidth > (double) 0) {
      executeCommand(CMD_HMI,
                     "".concat(String.valueOf(String.valueOf(jobSetup.columnWidth))));
    }
    if (jobSetup.interspacing.length() > 0) {
      processCommandsForLineSpacing(jobSetup.interspacing);
    }
    if (jobSetup.condensed) {
      executeCommand(CMD_CONDENSED_ON);
    }
    if (!topMarginPerSoftware) {
      executeCommand(CMD_TOP_MARGIN,
                     "".concat(String.valueOf(String.valueOf(jobSetup.topMargin))));
      executeCommand(CMD_BOTTOM_MARGIN,
                     "".concat(String.valueOf(String.valueOf(jobSetup.
          bottomMargin))));
    }
    else {
      executeCommand(CMD_TOP_MARGIN, "0");
      executeCommand(CMD_BOTTOM_MARGIN, "0");
    }
    if (supportsCommand(CMD_PAGE_LENGTH_INCHES) && jobSetup.paperSize != null) {
      executeCommand(CMD_PAGE_LENGTH_INCHES,
                     "".concat(String.valueOf(String.
                                              valueOf(jobSetup.paperSize.getHeight()))));
    }
    else {
      executeCommand(CMD_PAGE_LENGTH_LINES,
                     "".concat(String.valueOf(String.valueOf(jobSetup.rows))));
    }
    if (!leftMarginPerSoftware) {
      executeCommand(CMD_LEFT_MARGIN,
                     "".concat(String.valueOf(String.valueOf(jobSetup.
          leftMargin))));
      executeCommand(CMD_RIGHT_MARGIN,
                     "".concat(String.valueOf(String.valueOf(jobSetup.cols -
          jobSetup.rightMargin))));
    }
    else {
      executeCommand(CMD_LEFT_MARGIN, "0");
      executeCommand(CMD_RIGHT_MARGIN,
                     "".concat(String.valueOf(String.valueOf(jobSetup.cols))));
    }
    if (jobSetup.draftQuality) {
      executeCommand(CMD_DRAFT);
    }
    else {
      executeCommand(CMD_QUALITY);
    }
    if (defaultCharSet.length() > 0) {
      processCommandsForCharacterSet("", defaultCharSet);
    }
    addToBuffer(jobSetup.userDefinedCommands);
    if (debug) {
      System.out.println("User command: ".concat(String.valueOf(String.valueOf(
          jobSetup.userDefinedCommands))));
    }
  }

  protected void calculateLineSpacing(int rows) {
    if (jobSetup.paperSize == null) {
      return;
    }
    if (jobSetup.interspacing.length() == 0) {
      jobSetup.interspacing = getBestLineSpacing(rows,
                                                 jobSetup.paperSize.getHeight());
    }
  }

  protected void calculateColumnWidth(int cols) {
    if (jobSetup.paperSize == null) {
      return;
    }
    double requiredHMI = jobSetup.paperSize.getWidth() / (double) cols;
    double requiredPitch = (double) 1 / requiredHMI;
    if (jobSetup.pitch == (double) - 1) {
      jobSetup.pitch = requiredPitch;
    }
    if (jobSetup.columnWidth == (double) - 1) {
      jobSetup.columnWidth = requiredHMI;
    }
    if (debug) {
      System.out.println(String.valueOf(String.valueOf( (new StringBuffer(
          "Settings for ")).append(cols).append(" columns and paper width ").
          append(jobSetup.paperSize.getWidth()).append(" inches:"))));
      System.out.println("Pitch: ".concat(String.valueOf(String.valueOf(
          jobSetup.pitch))));
      System.out.println("HMI: ".concat(String.valueOf(String.valueOf(jobSetup.
          columnWidth))));
    }
  }

  public void startJob(PrinterPort p, JobProperties prop) throws
      TextPrinterException {
    System.out.println("printing started....");
    jobSetup = prop;
    resetPageData();
    port = p;
    port.open();
    currentProp = getDefaultTextProperties();
    processCommandsForJob();
  }

  public void endJob() throws TextPrinterException {
    finishPage();
    flushBuffer();
    port.close();
  }

  protected void resetPageData() {
    currentRow = jobSetup.topMargin;
    currentCol = jobSetup.leftMargin;
    pageData = new char[jobSetup.rows][jobSetup.cols];
    pageDataProperties = new TextProperties[jobSetup.rows][jobSetup.cols];
  }

  protected void flushBuffer() throws TextPrinterException {
    if (bufferPointer > 0) {
      port.write(buffer, bufferPointer);
    }
    bufferPointer = 0;
  }

  protected byte[] charMapping(char c, TextProperties prop) throws
      UnsupportedEncodingException, TextPrinterException {
    String s = "".concat(String.valueOf(String.valueOf(c)));
    if (!performCharSetConversion) {
      return s.getBytes(jobSetup.javaEncoding);
    }
    if (prop == null) {
      prop = getDefaultTextProperties();
    }
    String sSet = prop.characterSet;
    if (sSet == null) {
      sSet = defaultCharSet;
    }
    if (sSet.length() == 0) {
      sSet = defaultCharSet;
    }
    if (sSet.length() == 0) {
      return s.getBytes(jobSetup.javaEncoding);
    }
    Charset set = charSetManager.getCharSet(sSet);
    if (set == null && charSetValues.containsKey(sSet)) {
      String sSet2 = ( (CommandCharSetValue) charSetValues.get(sSet)).charSet;
      if (sSet2.length() > 0) {
        set = charSetManager.getCharSet(sSet2);
      }
    }
    if (set != null) {
      byte mappedBytes[] = set.fromUnicode(s.substring(0,
                                           1).getBytes("UTF-16LE"));
      if (mappedBytes == null && jobSetup.autoChartSetSelection) {
        String newCharSet = getCharSetforUnicode(s.substring(0,
                                                 1).getBytes("UTF-16LE"));
        if (newCharSet != null) {
          Charset set2 = charSetManager.getCharSet(newCharSet);
          mappedBytes = set2.fromUnicode(s.substring(0, 1).getBytes("UTF-16LE"));
          prop.characterSet = newCharSet;
        }
      }
      return mappedBytes;
    }
    else {
      return s.getBytes(jobSetup.javaEncoding);
    }
  }

  protected String getCharSetforUnicode(byte b[]) {
    for (Enumeration e = charSetValues.elements(); e.hasMoreElements(); ) {
      CommandParamValue p = (CommandParamValue) e.nextElement();
      Charset c = charSetManager.getCharSet(p.name);
      if (c != null && c.fromUnicode(b) != null) {
        return p.name;
      }
    }

    return null;
  }

  protected void addToBuffer(String s) throws TextPrinterException {
    try {
      addToBuffer(s.getBytes(jobSetup.javaEncoding));
    }
    catch (UnsupportedEncodingException e) {
      throw new TextPrinterException(e.getMessage());
    }
  }

  protected void addToBuffer(byte b[]) throws TextPrinterException {
    boolean isCommand = false;
    if (b == null) {
      return;
    }
    for (int i = 0; i < b.length; i++) {
      if (debug) {
        if (i == 0) {
          if (b[i] == 10) {
            System.out.println("LF ");
          }
          else
          if (b[i] == 12) {
            System.out.print("FF ");
          }
          else
          if (b[i] == 13) {
            System.out.print("CR ");
          }
          else
          if (b[i] == 27) {
            System.out.print("ESC ");
            isCommand = true;
          }
          else {
            System.out.print(String.valueOf(String.valueOf( (new StringBuffer(
                String.valueOf(String.valueOf(Integer.toHexString(b[i]).
                                              toUpperCase())))).append("(").
                append(new String(b)).append(") "))));
          }
        }
        else
        if (isCommand) {
          System.out.print(String.valueOf(String.valueOf( (new StringBuffer(
              String.valueOf(String.valueOf(Integer.toHexString(b[i]).
                                            toUpperCase())))).append("(").
              append(new String(b, i, 1)).append(") "))));
        }
        else {
          System.out.print(String.valueOf(String.valueOf( (new StringBuffer(
              String.valueOf(String.valueOf(Integer.toHexString(b[i]).
                                            toUpperCase())))).append("(").
              append(new String(b)).append(") "))));
        }
      }
      try {
        buffer[bufferPointer++] = b[i];
        if (bufferPointer == bufferSize) {
          flushBuffer();
        }
        continue;
      }
      catch (Exception e) {
        e.printStackTrace();
      }
      return;
    }

  }

  public String[] getSupportedCharSets() {
    Enumeration e = charSetValues.elements();
    Vector v = new Vector();
    while (e.hasMoreElements()) {
      CommandCharSetValue p = (CommandCharSetValue) e.nextElement();
      if (p.charSet.length() > 0) {
        v.addElement(p.charSet);
      }
      else {
        v.addElement( ( (CommandParamValue) (p)).name);
      }
    }
    return _$4126(v);
  }

  public String[] getFirstElements(String t[][]) {
    Vector v = new Vector();
    for (int i = 0; i < t.length; i++) {
      v.addElement(t[i][0]);

    }
    return _$4126(v);
  }

  public Enumeration getSupportedFonts() {
    return fontValues.elements();
  }

  public Enumeration getSupportedCharPitch() {
    return pitchValues.elements();
  }

  public Enumeration getSupportedInterspaing() {
    return interspacingValues.elements();
  }

  private String[] _$4126(Vector v) {
    return (String[]) v.toArray();
  }

  public void printArray(String t[]) throws TextPrinterException {
    for (int i = 0; i < t.length; i++) {
      printString(t[i], getDefaultTextProperties());
      //System.out.println(t[i]);

    }
  }

  public JobProperties getDefaultJobProperties() {
    JobProperties j = new JobProperties();
    j.topMargin = 0;
    return j;
  }

  public TextProperties getDefaultTextProperties() {
    TextProperties t = new TextProperties();
    _$2842(t);
    if (jobSetup != null) {
      t.proportional = jobSetup.proportional;
      t.condensed = jobSetup.condensed;
    }
    return t;
  }

  private void _$2842(TextProperties t) {
    if (jobSetup != null) {
      if (t.pitch <= (double) 0) {
        t.pitch = jobSetup.pitch;
      }
      if (t.characterSet.length() == 0) {
        t.characterSet = defaultCharSet;
      }
    }
  }

  private boolean _$4257(int line, int col, char c[]) {
    if (line >= pageData.length) {
      return false;
    }
    if (col >= pageData[line].length) {
      return false;
    }
    for (int i = 0; i < c.length; i++) {
      if (pageData[line][col] == c[i]) {
        return true;
      }
    }

    return false;
  }

  private void _$2731(int line, int col, boolean firstInLine,
                      boolean lastInLine, TextProperties t) {
    if (line >= pageData.length) {
      return;
    }
    if (col >= pageData[0].length) {
      return;
    }
    if (_$4257(line, col, new char[] {
               hLineChar, hbLineChar, htLineChar, crossLineChar
    })) {
      return;
    }
    if (lastInLine && _$4257(line, col, new char[] {
                             trCornerChar, brCornerChar
    })) {
      return;
    }
    if (firstInLine && _$4257(line, col, new char[] {
                              tlCornerChar, blCornerChar
    })) {
      return;
    }
    if (firstInLine && _$4257(line, col, new char[] {
                              vrLineChar
    })) {
      return;
    }
    if (lastInLine && _$4257(line, col, new char[] {
                             vlLineChar
    })) {
      return;
    }
    if (pageData[line][col] == vLineChar) {
      if (_$4257(line + 1, col, new char[] {
                 htLineChar, vLineChar, vrLineChar, vlLineChar, blCornerChar,
                 brCornerChar, crossLineChar
      }) && !_$4257(line - 1, col, new char[] {
                    hbLineChar, vLineChar, vrLineChar, vlLineChar, tlCornerChar,
                    trCornerChar, crossLineChar
      })) {
        if (lastInLine) {
          printChar(trCornerChar, line, col, t);
        }
        else
        if (firstInLine) {
          printChar(tlCornerChar, line, col, t);
        }
        else {
          printChar(hbLineChar, line, col, t);
        }
        return;
      }
      if (!_$4257(line + 1, col, new char[] {
                  htLineChar, vLineChar, vrLineChar, vlLineChar, blCornerChar,
                  brCornerChar, crossLineChar
      }) && _$4257(line - 1, col, new char[] {
                   hbLineChar, vLineChar, vrLineChar, vlLineChar, tlCornerChar,
                   trCornerChar, crossLineChar
      })) {
        if (lastInLine) {
          printChar(brCornerChar, line, col, t);
        }
        else
        if (firstInLine) {
          printChar(blCornerChar, line, col, t);
        }
        else {
          printChar(htLineChar, line, col, t);
        }
        return;
      }
      if (_$4257(line + 1, col, new char[] {
                 htLineChar, vLineChar, vrLineChar, vlLineChar, blCornerChar,
                 brCornerChar, crossLineChar
      }) && _$4257(line - 1, col, new char[] {
                   hbLineChar, vLineChar, vrLineChar, vlLineChar, tlCornerChar,
                   trCornerChar, crossLineChar
      })) {
        if (lastInLine) {
          printChar(vlLineChar, line, col, t);
        }
        else
        if (firstInLine) {
          printChar(vrLineChar, line, col, t);
        }
        else {
          printChar(crossLineChar, line, col, t);
        }
        return;
      }
      if (lastInLine) {
        printChar(vlLineChar, line, col, t);
      }
      else
      if (firstInLine) {
        printChar(vrLineChar, line, col, t);
      }
      else {
        printChar(crossLineChar, line, col, t);
      }
      return;
    }
    if (pageData[line][col] == vrLineChar || pageData[line][col] == vlLineChar) {
      printChar(crossLineChar, line, col, t);
      return;
    }
    if (pageData[line][col] == trCornerChar ||
        pageData[line][col] == tlCornerChar) {
      printChar(hbLineChar, line, col, t);
      return;
    }
    if (pageData[line][col] == brCornerChar ||
        pageData[line][col] == blCornerChar) {
      printChar(htLineChar, line, col, t);
      return;
    }
    else {
      printChar(hLineChar, line, col, t);
      return;
    }
  }

  private void _$2764(int line, int col, boolean firstInLine,
                      boolean lastInLine, TextProperties t) {
    if (line >= pageData.length) {
      return;
    }
    if (col >= pageData[0].length) {
      return;
    }
    if (_$4257(line, col, new char[] {
               vLineChar, vlLineChar, vrLineChar, crossLineChar
    })) {
      return;
    }
    if (lastInLine && _$4257(line, col, new char[] {
                             brCornerChar, blCornerChar
    })) {
      return;
    }
    if (firstInLine && _$4257(line, col, new char[] {
                              tlCornerChar, trCornerChar
    })) {
      return;
    }
    if (firstInLine && _$4257(line, col, new char[] {
                              hbLineChar
    })) {
      return;
    }
    if (lastInLine && _$4257(line, col, new char[] {
                             htLineChar
    })) {
      return;
    }
    if (pageData[line][col] == hLineChar) {
      if (_$4257(line, col + 1, new char[] {
                 vlLineChar, hbLineChar, htLineChar, hLineChar, trCornerChar,
                 brCornerChar, crossLineChar
      }) && !_$4257(line, col - 1, new char[] {
                    vrLineChar, hbLineChar, htLineChar, hLineChar, tlCornerChar,
                    blCornerChar, crossLineChar
      })) {
        if (lastInLine) {
          printChar(blCornerChar, line, col, t);
        }
        else
        if (firstInLine) {
          printChar(tlCornerChar, line, col, t);
        }
        else {
          printChar(vrLineChar, line, col, t);
        }
        return;
      }
      if (!_$4257(line, col + 1, new char[] {
                  vlLineChar, hbLineChar, htLineChar, hLineChar, trCornerChar,
                  brCornerChar, crossLineChar
      }) && _$4257(line, col - 1, new char[] {
                   vrLineChar, hbLineChar, htLineChar, hLineChar, tlCornerChar,
                   blCornerChar, crossLineChar
      })) {
        if (lastInLine) {
          printChar(brCornerChar, line, col, t);
        }
        else
        if (firstInLine) {
          printChar(trCornerChar, line, col, t);
        }
        else {
          printChar(vlLineChar, line, col, t);
        }
        return;
      }
      if (_$4257(line, col + 1, new char[] {
                 vlLineChar, hbLineChar, htLineChar, hLineChar, trCornerChar,
                 brCornerChar, crossLineChar
      }) && _$4257(line, col - 1, new char[] {
                   vrLineChar, hbLineChar, htLineChar, hLineChar, tlCornerChar,
                   blCornerChar, crossLineChar
      })) {
        if (lastInLine) {
          printChar(htLineChar, line, col, t);
        }
        else
        if (firstInLine) {
          printChar(hbLineChar, line, col, t);
        }
        else {
          printChar(crossLineChar, line, col, t);
        }
        return;
      }
      if (lastInLine) {
        printChar(htLineChar, line, col, t);
      }
      else
      if (firstInLine) {
        printChar(hbLineChar, line, col, t);
      }
      else {
        printChar(crossLineChar, line, col, t);
      }
      return;
    }
    if (pageData[line][col] == hbLineChar || pageData[line][col] == htLineChar) {
      printChar(crossLineChar, line, col, t);
      return;
    }
    if (pageData[line][col] == blCornerChar ||
        pageData[line][col] == tlCornerChar) {
      printChar(vlLineChar, line, col, t);
      return;
    }
    if (pageData[line][col] == brCornerChar ||
        pageData[line][col] == trCornerChar) {
      printChar(vrLineChar, line, col, t);
      return;
    }
    else {
      printChar(vLineChar, line, col, t);
      return;
    }
  }

  protected void addFont(String name, String valueOrCommand) {
    addParamValue(fontValues, new CommandParamValue(name, valueOrCommand));
  }

  protected void addCharSet(String name, String valueOrCommand, String charSet) {
    addParamValue(charSetValues,
                  new CommandCharSetValue(name, valueOrCommand, charSet));
  }

  protected void addParamValue(Hashtable table, CommandParamValue val) {
    if (table.containsKey(val.name)) {
      table.remove(val.name);
    }
    val.value = Command.parseCommand(val.value);
    table.put(val.name, val);
  }

  protected void addPitch(String name, String valueOrCommand) {
    addParamValue(pitchValues, new CommandParamValue(name, valueOrCommand));
  }

  protected void addSpacing(String name, String valueOrCommand) {
    addParamValue(interspacingValues,
                  new CommandParamValue(name, valueOrCommand));
  }

  protected void addPaperSize(String name, String valueOrCommand) {
    addParamValue(paperSizeValues, new CommandParamValue(name, valueOrCommand));
  }

  protected void addResolution(String name, String valueOrCommand) {
    addParamValue(resolutionValues, new CommandParamValue(name, valueOrCommand));
  }

  protected final char ESC = '\033';
  protected final char LF = '\n';
  protected final char CR = '\r';
  protected final char FF = '\f';
  protected Hashtable commands;
  protected static String CMD_RESET = "CMD_RESET";
  protected static String CMD_BOLD_ON = "CMD_BOLD_ON";
  protected static String CMD_BOLD_OFF = "CMD_BOLD_OFF";
  protected static String CMD_HORIZONTAL_POSITIONING =
      "CMD_HORIZONTAL_POSITIONING";
  protected static String CMD_ITALIC_ON = "CMD_ITALIC_ON";
  protected static String CMD_ITALIC_OFF = "CMD_ITALIC_OFF";
  protected static String CMD_DOUBLESTRIKE_ON = "CMD_DOUBLESTRIKE_ON";
  protected static String CMD_DOUBLESTRIKE_OFF = "CMD_DOUBLESTRIKE_OFF";
  protected static String CMD_UNDERLINED_ON = "CMD_UNDERLINED_ON";
  protected static String CMD_UNDERLINED_OFF = "CMD_UNDERLINED_OFF";
  protected static String CMD_DOUBLEWIDE_ON = "CMD_DOUBLEWIDE_ON";
  protected static String CMD_DOUBLEWIDE_OFF = "CMD_DOUBLEWIDE_OFF";
  protected static String CMD_CONDENSED_ON = "CMD_CONDENSED_ON";
  protected static String CMD_CONDENSED_OFF = "CMD_CONDENSED_OFF";
  protected static String CMD_SUBSCRIPT_ON = "CMD_SUBSCRIPT_ON";
  protected static String CMD_SUBSCRIPT_OFF = "CMD_SUBSCRIPT_OFF";
  protected static String CMD_SUPERSCRIPT_ON = "CMD_SUPERSCRIPT_ON";
  protected static String CMD_SUPERSCRIPT_OFF = "CMD_SUPERSCRIPT_OFF";
  protected static String CMD_PAGE_LENGTH_LINES = "CMD_PAGE_LENGTH_LINES";
  protected static String CMD_PAGE_LENGTH_INCHES = "CMD_PAGE_LENGTH_INCHES";
  protected static String CMD_PAGE_WIDTH = "CMD_PAGE_WIDTH";
  protected static String CMD_TOP_MARGIN = "CMD_TOP_MARGIN";
  protected static String CMD_BOTTOM_MARGIN = "CMD_BOTTOM_MARGIN";
  protected static String CMD_LEFT_MARGIN = "CMD_LEFT_MARGIN";
  protected static String CMD_RIGHT_MARGIN = "CMD_RIGHT_MARGIN";
  protected static String CMD_SELECT_FONT = "CMD_SELECT_FONT";
  protected static String CMD_SELECT_CHAR_SET = "CMD_SELECT_CHAR_SET";
  protected static String CMD_PITCH = "CMD_PITCH";
  protected static String CMD_PROPORTIONAL_ON = "CMD_PROPORTIONAL_ON";
  protected static String CMD_PROPORTIONAL_OFF = "CMD_PROPORTIONAL_OFF";
  protected static String CMD_PORTRAIT = "CMD_PORTRAIT";
  protected static String CMD_LANDSCAPE = "CMD_LANDSCAPE";
  protected static String CMD_INTERSPACE = "CMD_INTERSPACE";
  protected static String CMD_QUALITY = "CMD_QUALITY";
  protected static String CMD_DRAFT = "CMD_DRAFT";
  protected static String CMD_HMI = "CMD_HMI";
  protected static String CMD_PAPER_SIZE = "CMD_PAPER_SIZE";
  protected static String CMD_RESOLUTION = "CMD_RESOLUTION";
  protected Hashtable fontValues;
  protected Hashtable charSetValues;
  protected Hashtable pitchValues;
  protected Hashtable interspacingValues;
  protected Hashtable paperSizeValues;
  protected Hashtable resolutionValues;
  protected Hashtable cmdDependencies;
  protected boolean bLFfterCR;
  protected char pageData[][];
  protected TextProperties pageDataProperties[][];
  protected JobProperties jobSetup;
  protected int currentRow;
  protected int currentCol;
  protected PrinterPort port;
  protected int bufferSize;
  protected int bufferPointer;
  protected byte buffer[];
  protected boolean leftMarginPerSoftware;
  protected boolean topMarginPerSoftware;
  protected boolean feedFormPerSoftware;
  public char hLineChar;
  public char vLineChar;
  public char vrLineChar;
  public char vlLineChar;
  public char htLineChar;
  public char hbLineChar;
  public char crossLineChar;
  public char tlCornerChar;
  public char trCornerChar;
  public char blCornerChar;
  public char brCornerChar;
  public String linesCharSet;
  public boolean performCharSetConversion;
  public String defaultCharSet;
  public boolean debug;
  public boolean calculatePitchAndHMI;
  public boolean calculateLineSpacing;
  protected CharSetManager charSetManager;
  TextProperties currentProp;
  char emptyCharater;
  //private int _$2242;

  public static final class TextPoint {
    public int col, row;

    public TextPoint() {
      col = row = 0;
    }

    public TextPoint(int c, int r) {
      col = c;
      row = r;
    }

    public String toString() {
      return "TextPoint {row: " + row + ", col:" + col + "}";
    }

  }

}
