// Decompiled by Jad v1.5.8f. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   FilePort.java

package com.java4less.textprinter.ports;

import com.java4less.textprinter.PrinterPort;
import com.java4less.textprinter.TextPrinterException;
import com.java4less.textprinter.exceptions.CouldNotOpenPrinterException;
import java.io.FileOutputStream;

public class FilePort extends PrinterPort
    implements Runnable
{

    public FilePort(String filename)
    {
        sFilename = "";
        os = null;
        closed = true;
        writeError = null;
        dataToWrite = null;
        dataToWriteLen = 0;
        sFilename = filename;
    }

    public void open()
        throws TextPrinterException
    {
        try
        {
            os = new FileOutputStream(sFilename);
            closed = false;
        }
        catch(Exception e)
        {
            CouldNotOpenPrinterException t = new CouldNotOpenPrinterException(e.getMessage());
            throw t;
        }
    }

    public void close()
        throws TextPrinterException
    {
        try
        {
            closed = true;
            os.close();
        }
        catch(Exception e)
        {
            TextPrinterException t = new TextPrinterException(e.getMessage());
            throw t;
        }
    }

    public void write(String s)
        throws TextPrinterException
    {
        write(s.getBytes());
    }

    public void write(byte s[], int len)
        throws TextPrinterException
    {
        try
        {
            dataToWrite = s;
            dataToWriteLen = len;
            writeError = null;
            Thread writerThread = null;
            writerThread = new Thread(this);
            writerThread.start();
            writerThread.join(super.timeout);
            if(writerThread.isAlive())
            {
                writerThread.stop();
                TextPrinterException t = new TextPrinterException("Could not write to printer file. Timeout.");
                throw t;
            }
            if(writeError != null)
            {
                TextPrinterException t = new TextPrinterException("Could not write to printer file. ".concat(String.valueOf(String.valueOf(writeError))));
                throw t;
            }
        }
        catch(Exception e)
        {
            TextPrinterException t = new TextPrinterException(e.getMessage());
            throw t;
        }
    }

    public void run()
    {
        try
        {
            writeError = null;
            os.write(dataToWrite, 0, dataToWriteLen);
        }
        catch(Exception e1)
        {
            writeError = e1.getMessage();
        }
    }

    String sFilename;
    FileOutputStream os;
    boolean closed;
    String writeError;
    byte dataToWrite[];
    int dataToWriteLen;
}
